package org.cultrix.classic.converter;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.util.*;
import java.util.prefs.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.filechooser.FileFilter;

public class Converter
{
    public static final byte[] newLine = new byte[]{(byte)0xD, (byte)0xA};
    public static final String NL = new String(newLine);
    public static final String VERSION = "1.1.2";

    private static final String[] MAPTYPE = new String[]
    {
        "#CLEAN_MAP_TYPE_NONE",                     // 0
        "#CLEAN_MAP_TYPE_SINGLE_PLAYER_CAMPAIGN",   // 1
        "#CLEAN_MAP_TYPE_SINGLE_PLAYER_FREE",       // 2
        "#CLEAN_MAP_TYPE_SINGLE_PLAYER_DEMO",       // 3
        "#CLEAN_MAP_TYPE_MULTI_PLAYER_FREE",        // 4
        "#CLEAN_MAP_TYPE_USER_SINGLE_PLAYER_FREE",  // 5
        "#CLEAN_MAP_TYPE_USER_MULTI_PLAYER_FREE",   // 6
        "#CLEAN_MAP_TYPE_MAXIMUM"                   // 7
    };
    private static final String[] MUSICTYPE = new String[]
    {
        "#DM_MUSIC_TYPE_NOMUSIC",                   //  0
        "#DM_MUSIC_TYPE_CULTURE_MISSION",           //  1
        "#DM_MUSIC_TYPE_CULTURE_VIKING",            //  2
        "#DM_MUSIC_TYPE_CULTURE_FRANKEN",           //  3
        "#DM_MUSIC_TYPE_CULTURE_BYZANZ",            //  4
        "#DM_MUSIC_TYPE_CULTURE_ARABS",             //  5
        "#DM_MUSIC_TYPE_ATTACK_VIKING",             //  6
        "#DM_MUSIC_TYPE_ATTACK_FRANKEN",            //  7
        "#DM_MUSIC_TYPE_ATTACK_BYZANZ",             //  8
        "#DM_MUSIC_TYPE_ATTACK_ARABS",              //  9
        "#DM_MUSIC_TYPE_MISSION_VIKING1",           // 10
        "#DM_MUSIC_TYPE_MISSION_FRANKEN1",          // 11
        "#DM_MUSIC_TYPE_MISSION_FRANKEN2",          // 12
        "#DM_MUSIC_TYPE_MISSION_BYZANZ1",           // 13
        "#DM_MUSIC_TYPE_MISSION_BYZANZ2",           // 14
        "#DM_MUSIC_TYPE_MISSION_BYZANZ3",           // 15
        "#DM_MUSIC_TYPE_MISSION_BYZANZ4",           // 16
        "#DM_MUSIC_TYPE_MISSION_ARABS1",            // 17
        "#DM_MUSIC_TYPE_MISSION_ARABS2",            // 18
        "#DM_MUSIC_TYPE_MISSION_ARABS3",            // 19
        "#DM_MUSIC_TYPE_MISSION_MIDGARD1",          // 20
        "#DM_MUSIC_TYPE_MISSION_MIDGARD2",          // 21
        "#DM_MUSIC_TYPE_JINGLE_MARRIAGE",           // 22
        "#DM_MUSIC_TYPE_JINGLE_BIRTH",              // 23
        "#DM_MUSIC_TYPE_JINGLE_CIVILDEFENSE",       // 24
        "#DM_MUSIC_TYPE_JINGLE_DEATH",              // 25
        "#DM_MUSIC_TYPE_JINGLE_HOUSEBUILT",         // 26
        "#DM_MUSIC_TYPE_JINGLE_WON",                // 27
        "#DM_MUSIC_TYPE_JINGLE_LOST",               // 28
        "#DM_MUSIC_TYPE_JINGLE_TECHNOLOGY",         // 29
        "#DM_MUSIC_TYPE_JINGLE_OPENCHEST",          // 30
        "#DM_MUSIC_TYPE_ADDON_MISSION_ARABS1",      // 31
        "#DM_MUSIC_TYPE_ADDON_MISSION_ARABS2",      // 32
        "#DM_MUSIC_TYPE_ADDON_MISSION_FRANKEN1",    // 33
        "#DM_MUSIC_TYPE_ADDON_MISSION_FRANKEN2",    // 34
        "#DM_MUSIC_TYPE_ADDON_MISSION_FRANKEN3",    // 35
        "#DM_MUSIC_TYPE_ADDON_MISSION_NORDLAND",    // 36
        "#DM_MUSIC_TYPE_ADDON_MISSION_UNDERWORLD",  // 37
        "#DM_MUSIC_TYPE_ADDON_MISSION_ASGARD",      // 38
        "#DM_MUSIC_TYPE_MAXIMUM"                    // 39
    };
    private static final String[] HOUSETYPE = new String[]
    {
        "#HOUSE_TYPE_NONE",                             //  0
        "#HOUSE_TYPE_HEADQUARTERS",                     //  1
        "#HOUSE_TYPE_HOME_00",                          //  2
        "#HOUSE_TYPE_HOME_01",                          //  3
        "#HOUSE_TYPE_HOME_02",                          //  4
        "#HOUSE_TYPE_HOME_03",                          //  5
        "#HOUSE_TYPE_HOME_04",                          //  6
        "#HOUSE_TYPE_STOCK_00",                         //  7
        "#HOUSE_TYPE_STOCK_01",                         //  8
        "#HOUSE_TYPE_STOCK_02",                         //  9
        "#HOUSE_TYPE_WORK_WELL",                        // 10
        "#HOUSE_TYPE_WORK_HIVE",                        // 11
        "#HOUSE_TYPE_WORK_FARM",                        // 12
        "#HOUSE_TYPE_WORK_MILL",                        // 13
        "#HOUSE_TYPE_WORK_BAKERY_00",                   // 14
        "#HOUSE_TYPE_WORK_BAKERY_01",                   // 15
        "#HOUSE_TYPE_WORK_BREWERY",                     // 16
        "#HOUSE_TYPE_WORK_BREEDERY",                    // 17
        "#HOUSE_TYPE_WORK_SEWERY_00",                   // 18
        "#HOUSE_TYPE_WORK_SEWERY_01",                   // 19
        "#HOUSE_TYPE_WORK_POTTERY_00",                  // 20
        "#HOUSE_TYPE_WORK_POTTERY_01",                  // 21
        "#HOUSE_TYPE_WORK_POTTERY_02",                  // 22
        "#HOUSE_TYPE_WORK_JOINERY_00",                  // 23
        "#HOUSE_TYPE_WORK_JOINERY_01",                  // 24
        "#HOUSE_TYPE_WORK_JOINERY_02",                  // 25
        "#HOUSE_TYPE_WORK_JOINERY_03",                  // 26
        "#HOUSE_TYPE_WORK_ARMORY_00",                   // 27
        "#HOUSE_TYPE_WORK_ARMORY_01",                   // 28
        "#HOUSE_TYPE_WORK_MASON_HUT_00",                // 29
        "#HOUSE_TYPE_WORK_MASON_HUT_01",                // 30
        "#HOUSE_TYPE_WORK_SMITHY_00",                   // 31
        "#HOUSE_TYPE_WORK_SMITHY_01",                   // 32
        "#HOUSE_TYPE_WORK_COIN_MINT",                   // 33
        "#HOUSE_TYPE_WORK_HERB_HUT",                    // 34
        "#HOUSE_TYPE_WORK_DRUID_HUT_00",                // 35
        "#HOUSE_TYPE_WORK_DRUID_HUT_01",                // 36
        "#HOUSE_TYPE_WORK_TEMPLE",                      // 37
        "#HOUSE_TYPE_LEARN_SCHOOL",                     // 38
        "#HOUSE_TYPE_LEARN_BARRACKS",                   // 39
        "#HOUSE_TYPE_FIGHT_TOWER_00",                   // 40
        "#HOUSE_TYPE_FIGHT_TOWER_01",                   // 41
        "#HOUSE_TYPE_VEHICLE_CART_HAND",                // 42
        "#HOUSE_TYPE_VEHICLE_CART_OX",                  // 43
        "#HOUSE_TYPE_VEHICLE_SHIP_SMALL",               // 44
        "#HOUSE_TYPE_VEHICLE_SHIP_BIG",                 // 45
        "#HOUSE_TYPE_VEHICLE_CATAPULT",                 // 46
        "#HOUSE_TYPE_WONDER_LIGHTHOUSE_OF_ALEXANDRIA",  // 47
        "#HOUSE_TYPE_WONDER_GARDENS_OF_SEMIRAMIS",      // 48
        "#HOUSE_TYPE_WONDER_RHODOS",                    // 49
        "#HOUSE_TYPE_WONDER_MAUSOLOS",                  // 50
        "#HOUSE_TYPE_WONDER_ARTEMIS_TEMPLE",            // 51
        "#HOUSE_TYPE_WONDER_ZEUS_STATUE",               // 52
        "#HOUSE_TYPE_WONDER_PYRAMID_OF_GIZEH",          // 53
        "#HOUSE_TYPE_WONDER_8TH_WONDER",                // 54
        "#HOUSE_TYPE_MAXIMUM"                           // 55
    };
    private static final String[] JOBTYPE = new String[]
    {
        "#JOB_TYPE_NONE",                       //  0
        "#JOB_TYPE_HUMAN_BABY_FEMALE",          //  1
        "#JOB_TYPE_HUMAN_BABY_MALE",            //  2
        "#JOB_TYPE_HUMAN_CHILD_FEMALE",         //  3
        "#JOB_TYPE_HUMAN_CHILD_MALE",           //  4
        "#JOB_TYPE_HUMAN_WOMAN",                //  5
        "#JOB_TYPE_HUMAN_CIVILIST",             //  6
        "#JOB_TYPE_HUMAN_BUILDER",              //  7
        "#JOB_TYPE_HUMAN_COLLECTOR",            //  8
        "#JOB_TYPE_HUMAN_CARPENTER",            //  9
        "#JOB_TYPE_HUMAN_ARMORER",              // 10
        "#JOB_TYPE_HUMAN_POTTER",               // 11
        "#JOB_TYPE_HUMAN_MASON",                // 12
        "#JOB_TYPE_HUMAN_SMITH",                // 13
        "#JOB_TYPE_HUMAN_COINER",               // 14
        "#JOB_TYPE_HUMAN_HUNTER",               // 15
        "#JOB_TYPE_HUMAN_BREEDER",              // 16
        "#JOB_TYPE_HUMAN_SEWER",                // 17
        "#JOB_TYPE_HUMAN_FARMER",               // 18
        "#JOB_TYPE_HUMAN_MILLER",               // 19
        "#JOB_TYPE_HUMAN_BAKER",                // 20
        "#JOB_TYPE_HUMAN_BREWER",               // 21
        "#JOB_TYPE_HUMAN_FISHER",               // 22
        "#JOB_TYPE_HUMAN_FISHER_SEA",           // 23
        "#JOB_TYPE_HUMAN_CARRIER",              // 24
        "#JOB_TYPE_HUMAN_TRADER",               // 25
        "#JOB_TYPE_HUMAN_TRADER_SEA",           // 26
        "#JOB_TYPE_HUMAN_SCOUT",                // 27
        "#JOB_TYPE_HUMAN_JESTER",               // 28
        "#JOB_TYPE_HUMAN_HERB_GUY",             // 29
        "#JOB_TYPE_HUMAN_DRUID",                // 30
        "#JOB_TYPE_HUMAN_SOLDIER_UNARMED",      // 31
        "#JOB_TYPE_HUMAN_SOLDIER_SPEAR_WOODEN", // 32
        "#JOB_TYPE_HUMAN_SOLDIER_SPEAR_IRON",   // 33
        "#JOB_TYPE_HUMAN_SOLDIER_SWORD_SHORT",  // 34
        "#JOB_TYPE_HUMAN_SOLDIER_SWORD_LONG",   // 35
        "#JOB_TYPE_HUMAN_SOLDIER_SABER_SHORT",  // 36
        "#JOB_TYPE_HUMAN_SOLDIER_SABER_LONG",   // 37
        "#JOB_TYPE_HUMAN_SOLDIER_AXE_SMALL",    // 38
        "#JOB_TYPE_HUMAN_SOLDIER_AXE_BIG",      // 39
        "#JOB_TYPE_HUMAN_SOLDIER_BOW_SHORT",    // 40
        "#JOB_TYPE_HUMAN_SOLDIER_BOW_LONG",     // 41
        "#JOB_TYPE_HUMAN_HERO_UNARMED",         // 42
        "#JOB_TYPE_HUMAN_HERO_SPEAR",           // 43
        "#JOB_TYPE_HUMAN_HERO_SWORD",           // 44
        "#JOB_TYPE_HUMAN_HERO_SABER",           // 45
        "#JOB_TYPE_HUMAN_HERO_AXE",             // 46
        "#JOB_TYPE_HUMAN_HERO_BOW",             // 47
        "#JOB_TYPE_ANIMAL_BABY",                // 48
        "#JOB_TYPE_ANIMAL_ADULT",               // 49
        "#JOB_TYPE_VEHICLE_CART_HAND",          // 50
        "#JOB_TYPE_VEHICLE_CART_OX",            // 51
        "#JOB_TYPE_VEHICLE_SHIP_SMALL",         // 52
        "#JOB_TYPE_VEHICLE_SHIP_BIG",           // 53
        "#JOB_TYPE_VEHICLE_CATAPULT",           // 54
        "#JOB_TYPE_VEHICLE_CART_NO_OX",         // 55
        "#JOB_TYPE_MAXIMUM"                     // 56
    };
    private static final String[] GOODTYPE = new String[]
    {
        "#GOOD_TYPE_NONE",                   //  0
        "#GOOD_TYPE_WATER",                  //  1
        "#GOOD_TYPE_MUD",                    //  2
        "#GOOD_TYPE_STONE",                  //  3
        "#GOOD_TYPE_WHEAT",                  //  4
        "#GOOD_TYPE_WOOD",                   //  5
        "#GOOD_TYPE_IRON",                   //  6
        "#GOOD_TYPE_GOLD",                   //  7
        "#GOOD_TYPE_COIN",                   //  8
        "#GOOD_TYPE_LEATHER",                //  9
        "#GOOD_TYPE_WOOL",                   // 10
        "#GOOD_TYPE_FLOUR",                  // 11
        "#GOOD_TYPE_HONEY",                  // 12
        "#GOOD_TYPE_HERB",                   // 13
        "#GOOD_TYPE_MUSHROOM",               // 14
        "#GOOD_TYPE_HOLYOIL",                // 15
        "#GOOD_TYPE_FOOD_SIMPLE",            // 16
        "#GOOD_TYPE_FOOD_EXTRA",             // 17
        "#GOOD_TYPE_FRUIT",                  // 18
        "#GOOD_TYPE_BREAD",                  // 19
        "#GOOD_TYPE_CANDY",                  // 20
        "#GOOD_TYPE_MEAT",                   // 21
        "#GOOD_TYPE_FISH",                   // 22
        "#GOOD_TYPE_SAUSAGE",                // 23
        "#GOOD_TYPE_BRICK",                  // 24
        "#GOOD_TYPE_TILE",                   // 25
        "#GOOD_TYPE_PILLAR",                 // 26
        "#GOOD_TYPE_ORNAMENT",               // 27
        "#GOOD_TYPE_CROCKERY",               // 28
        "#GOOD_TYPE_FURNITURE",              // 29
        "#GOOD_TYPE_SHOES",                  // 30
        "#GOOD_TYPE_TOOL_WOODEN",            // 31
        "#GOOD_TYPE_TOOL_IRON",              // 32
        "#GOOD_TYPE_ARMOR_WOOL",             // 33
        "#GOOD_TYPE_ARMOR_LEATHER",          // 34
        "#GOOD_TYPE_ARMOR_CHAIN",            // 35
        "#GOOD_TYPE_ARMOR_PLATE",            // 36
        "#GOOD_TYPE_BOW_SHORT",              // 37
        "#GOOD_TYPE_BOW_LONG",               // 38
        "#GOOD_TYPE_SPEAR_WOODEN",           // 39
        "#GOOD_TYPE_SPEAR_IRON",             // 40
        "#GOOD_TYPE_SWORD_SHORT",            // 41
        "#GOOD_TYPE_SWORD_LONG",             // 42
        "#GOOD_TYPE_MEAD",                   // 43
        "#GOOD_TYPE_POTION_FOOD_SMALL",      // 44
        "#GOOD_TYPE_POTION_FOOD_BIG",        // 45
        "#GOOD_TYPE_POTION_STAMINA_SMALL",   // 46
        "#GOOD_TYPE_POTION_STAMINA_BIG",     // 47
        "#GOOD_TYPE_POTION_HEALING_SMALL",   // 48
        "#GOOD_TYPE_POTION_HEALING_BIG",     // 49
        "#GOOD_TYPE_AMULET_FOOD",            // 50
        "#GOOD_TYPE_AMULET_STAMINA",         // 51
        "#GOOD_TYPE_AMULET_STRENGTH",        // 52
        "#GOOD_TYPE_AMULET_DEFENSE",         // 53
        "#GOOD_TYPE_AMULET_CRITICAL_HIT",    // 54
        "#GOOD_TYPE_AMULET_SPEED",           // 55
        "#GOOD_TYPE_ANIMAL_PREY",            // 56
        "#GOOD_TYPE_ANIMAL_SHEEP",           // 57
        "#GOOD_TYPE_ANIMAL_CATTLE",          // 58
        "#GOOD_TYPE_VEHICLE_CART_HAND",      // 59
        "#GOOD_TYPE_VEHICLE_CART_OX",        // 60
        "#GOOD_TYPE_VEHICLE_SHIP_SMALL",     // 61
        "#GOOD_TYPE_VEHICLE_SHIP_BIG",       // 62
        "#GOOD_TYPE_VEHICLE_CATAPULT",       // 63
        "#GOOD_TYPE_SPECIAL_CHEST",          // 64
        "#GOOD_TYPE_SPECIAL_ANYTHING",       // 65
        "#GOOD_TYPE_MAXIMUM"                 // 66
    };
    private static final String[] PLAYERTYPE = new String[]
    {
        "#PLAYER_TYPE_NONE",    // 0
        "#PLAYER_TYPE_HUMAN",   // 1
        "#PLAYER_TYPE_AI",      // 2
        "#PLAYER_TYPE_MAXIMUM"  // 3
    };
    private static final String[] TRIBETYPE = new String[]
    {
        "#TRIBE_TYPE_NONE",                 //  0
        "#TRIBE_TYPE_HUMAN_VIKING",         //  1
        "#TRIBE_TYPE_HUMAN_FRANK",          //  2
        "#TRIBE_TYPE_HUMAN_BYZANTINE",      //  3
        "#TRIBE_TYPE_HUMAN_SARACEN",        //  4
        "#TRIBE_TYPE_HUMAN_WERESNAKE",      //  5
        "#TRIBE_TYPE_HUMAN_WEREWOLF",       //  6
        "#TRIBE_TYPE_HUMAN_EGYPT",          //  7
        "#TRIBE_TYPE_ANIMAL_BEARS",         //  8
        "#TRIBE_TYPE_ANIMAL_BOARS",         //  9
        "#TRIBE_TYPE_ANIMAL_CATTLE",        // 10
        "#TRIBE_TYPE_ANIMAL_DEERSMALE",     // 11
        "#TRIBE_TYPE_ANIMAL_DEERSFEMALE",   // 12
        "#TRIBE_TYPE_ANIMAL_DOGS",          // 13
        "#TRIBE_TYPE_ANIMAL_GOATSTAME",     // 14
        "#TRIBE_TYPE_ANIMAL_GOATSWILD",     // 15
        "#TRIBE_TYPE_ANIMAL_RABBITSBROWN",  // 16
        "#TRIBE_TYPE_ANIMAL_RABBITSWHITE",  // 17
        "#TRIBE_TYPE_ANIMAL_RABBITSEVIL",   // 18
        "#TRIBE_TYPE_ANIMAL_SHEEP",         // 19
        "#TRIBE_TYPE_ANIMAL_WOLVES",        // 20
        "#TRIBE_TYPE_ANIMAL_CAMELS",        // 21
        "#TRIBE_TYPE_ANIMAL_DROMEDARIES",   // 22
        "#TRIBE_TYPE_ANIMAL_ELEPHANTS",     // 23
        "#TRIBE_TYPE_ANIMAL_HORSES",        // 24
        "#TRIBE_TYPE_ANIMAL_LIONSMALE",     // 25
        "#TRIBE_TYPE_ANIMAL_LIONSFEMALE",   // 26
        "#TRIBE_TYPE_ANIMAL_BIRDSSPARROWS", // 27
        "#TRIBE_TYPE_ANIMAL_BIRDSRAVENS",   // 28
        "#TRIBE_TYPE_ANIMAL_BIRDSPARROTS",  // 29
        "#TRIBE_TYPE_ANIMAL_CHICKEN",       // 30
        "#TRIBE_TYPE_ANIMAL_DUCKS",         // 31
        "#TRIBE_TYPE_ANIMAL_GEESE",         // 32
        "#TRIBE_TYPE_ANIMAL_SWANS",         // 33
        "#TRIBE_TYPE_ANIMAL_BEES",          // 34
        "#TRIBE_TYPE_ANIMAL_BUTTERFLIES",   // 35
        "#TRIBE_TYPE_ANIMAL_MOSQUITOS",     // 36
        "#TRIBE_TYPE_ANIMAL_CRABS",         // 37
        "#TRIBE_TYPE_ANIMAL_FROGS",         // 38
        "#TRIBE_TYPE_ANIMAL_SCORPIONS",     // 39
        "#TRIBE_TYPE_ANIMAL_SNAKES",        // 40
        "#TRIBE_TYPE_ANIMAL_DRAGONS",       // 41
        "#TRIBE_TYPE_MAXIMUM"               // 42
    };
    private static final String[] COLOR = new String[]
    {
        "#PLAYER_COLOR_ID_BLUE",    //  0
        "#PLAYER_COLOR_ID_RED",     //  1
        "#PLAYER_COLOR_ID_YELLOW",  //  2
        "#PLAYER_COLOR_ID_CYAN",    //  3
        "#PLAYER_COLOR_ID_GREEN",   //  4
        "#PLAYER_COLOR_ID_PURPLE",  //  5
        "#PLAYER_COLOR_ID_GREY",    //  6
        "#PLAYER_COLOR_ID_ORANGE",  //  7
        "#PLAYER_COLOR_ID_NEON",    //  8
        "#PLAYER_COLOR_ID_BLACK",   //  9
        "#PLAYER_COLOR_ID_MAXIMUM"  // 10
    };
    private static final String[] DIPLOMACY = new String[]
    {
        "#DIPLOMACY_STATE_NONE",    // 0
        "#DIPLOMACY_STATE_FRIEND",  // 1
        "#DIPLOMACY_STATE_NEUTRAL", // 2
        "#DIPLOMACY_STATE_ENEMY",   // 3
        "#DIPLOMACY_STATE_MAXIMUM"  // 4
    };
    private static final String[] SPECIALITEMTYPE = new String[]
    {
        "#SPECIAL_ITEM_TYPE_NONE",                      // 0
        "#SPECIAL_ITEM_TYPE_LETTER_OF_INDULGENCE",      // 1
        "#SPECIAL_ITEM_TYPE_LETTER_TO_SET_ANY_HOUSE",   // 2
        "#SPECIAL_ITEM_TYPE_LETTER_TO_SET_GIVEN_HOUSE", // 3
        "#SPECIAL_ITEM_TYPE_LETTER_TO_ALLOW_A_HOUSE",   // 4
        "#SPECIAL_ITEM_TYPE_LETTER_TO_ALLOW_A_JOB",     // 5
        "#SPECIAL_ITEM_TYPE_LETTER_TO_ALLOW_GOOD",      // 6
        "#SPECIAL_ITEM_TYPE_MAXIMUM"                    // 7
    };
    private static final byte[][] FLAGS = new byte[][]
    {
        new byte[] // uk
        {
            (byte)71,(byte)73,(byte)70,(byte)56,(byte)55,(byte)97,(byte)16,(byte)0,(byte)12,(byte)0,(byte)194,(byte)5,(byte)0,(byte)0,(byte)0,(byte)153,(byte)0,(byte)0,(byte)204,(byte)153,(byte)0,(byte)0,(byte)204,(byte)0,(byte)0,(byte)204,(byte)204,(byte)204,(byte)255,(byte)255,(byte)255,(byte)255,(byte)255,(byte)255,(byte)255,(byte)255,(byte)255,(byte)44,(byte)0,(byte)0,(byte)0,(byte)0,(byte)16,(byte)0,(byte)12,(byte)0,(byte)0,(byte)3,(byte)63,(byte)72,(byte)4,(byte)12,(byte)36,(byte)98,(byte)181,(byte)40,(byte)70,(byte)41,(byte)33,(byte)148,(byte)97,(byte)51,(byte)47,(byte)75,(byte)240,(byte)105,(byte)223,(byte)118,(byte)5,(byte)76,(byte)38,(byte)94,(byte)95,(byte)151,(byte)57,(byte)87,(byte)188,(byte)89,(byte)50,(byte)88,(byte)113,(byte)120,(byte)158,(byte)67,(byte)122,(byte)143,(byte)71,(byte)181,(byte)89,(byte)48,(byte)148,(byte)49,(byte)149,(byte)6,(byte)170,(byte)20,(byte)139,(byte)213,(byte)153,(byte)161,(byte)8,(byte)78,(byte)146,(byte)139,(byte)69,(byte)105,(byte)56,(byte)32,(byte)18,(byte)134,(byte)34,(byte)1,(byte)0,(byte)59
        },
        new byte[] // de
        {
            (byte)71,(byte)73,(byte)70,(byte)56,(byte)55,(byte)97,(byte)16,(byte)0,(byte)12,(byte)0,(byte)194,(byte)5,(byte)0,(byte)0,(byte)0,(byte)0,(byte)204,(byte)0,(byte)0,(byte)255,(byte)0,(byte)0,(byte)204,(byte)204,(byte)0,(byte)255,(byte)255,(byte)0,(byte)255,(byte)255,(byte)255,(byte)255,(byte)255,(byte)255,(byte)255,(byte)255,(byte)255,(byte)44,(byte)0,(byte)0,(byte)0,(byte)0,(byte)16,(byte)0,(byte)12,(byte)0,(byte)0,(byte)3,(byte)34,(byte)8,(byte)186,(byte)220,(byte)254,(byte)48,(byte)202,(byte)24,(byte)132,(byte)189,(byte)24,(byte)135,(byte)154,(byte)187,(byte)221,(byte)158,(byte)7,(byte)134,(byte)89,(byte)48,(byte)16,(byte)104,(byte)170,(byte)170,(byte)195,(byte)185,(byte)190,(byte)104,(byte)11,(byte)195,(byte)109,(byte)109,(byte)223,(byte)117,(byte)2,(byte)0,(byte)59
        }
    };
    private static final String[][] LANG = new String[][]
    {
        new String[] // English
        {
            "English",
            "c2m Converter v{} (by Molt)",
            "Version {}",
            "Open file...",
            "Generate new GUID",
            "Enable this if you want to keep both the c2m and the unpacked map in your game folder.",
            "Cultures 2 Map (.c2m)",
            "Save as...",
            "Converting...",
            "Done",
            "Invalid file format.",
            "Invalid file contents.",
            "Nice try. Leave the lib alone.",
            "Unknown cif index: {}"
        },
        new String[] // German
        {
            "Deutsch",
            "c2m Konvertierer v{} (von Molt)",
            "Version {}",
            "Datei öffnen...",
            "Neue GUID erzeugen",
            "Wähle dies an, falls Du sowohl die c2m als auch den entpackten Ordner im Spielverzeichnis behalten möchtest.",
            "Cultures 2 Karte (.c2m)",
            "Speichern als...",
            "Konvertiere...",
            "Fertig",
            "Ungültiges Dateiformat.",
            "Ungültiger Dateiinhalt.",
            "Netter Versuch. Lass die lib in Frieden.",
            "Unbekannter cif Index: {}"
        }
    };

    private static JFrame frame;
    private static int lang = 0;
    private static File chooserIn = null;
    private static File chooserOut = null;

    public static void main(String[] args)
    {
        final Preferences config = Preferences.userNodeForPackage(Converter.class);
        String chIn = config.get("chooserIn", null);
        String chOut = config.get("chooserOut", null);
        String lng = config.get("lang", null);
        if(chIn != null)
        {
            chooserIn = new File(chIn);
        }
        if(chOut != null)
        {
            chooserOut = new File(chOut);
        }
        if(lng != null)
        {
            lang = lng.equals("de") ? 1 : 0;
        }
        else if(Locale.getDefault().getISO3Language().equals("deu"))
        {
            lang = 1;
        }
        frame = new JFrame(LANG[lang][1].replace("{}", VERSION));
        frame.setSize(400, 250);
        frame.pack();
        final Container content = frame.getContentPane();
        final int borderX = frame.getWidth() - content.getWidth();
        final int borderY = frame.getHeight() - content.getHeight();
        frame.setSize(400 + borderX, 250 + borderY);
        frame.setLocationByPlatform(true);
        frame.setMinimumSize(new Dimension(300 + borderX, 150 + borderY));
        frame.addWindowListener(new WindowAdapter()
        {
            public void windowClosing(WindowEvent e)
            {
                System.exit(0);
            }
        });
        final Label label = new Label(LANG[lang][2].replace("{}", VERSION));
        label.setSize(300, 40);
        label.setAlignment(Label.CENTER);
        final JCheckBox checkbox = new JCheckBox(LANG[lang][4], true);
        checkbox.setSize(300, 40);
        checkbox.setHorizontalAlignment(JCheckBox.CENTER);
        checkbox.setToolTipText(LANG[lang][5]);
        final Button button = new Button(LANG[lang][3]);
        button.setSize(300, 70);
        button.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                JFileChooser fileChooser = new JFileChooser();
                if(chooserIn != null && chooserIn.exists())
                {
                    fileChooser.setCurrentDirectory(chooserIn);
                }
                fileChooser.setDialogTitle(LANG[lang][3]);
                fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
                fileChooser.setDragEnabled(true);
                fileChooser.setFileFilter(new FileFilter()
                {
                    public boolean accept(File file)
                    {
                        return file.isDirectory() || file.getName().toLowerCase().endsWith(".c2m");
                    }

                    public String getDescription()
                    {
                        return LANG[lang][6];
                    }
                });
                fileChooser.setAcceptAllFileFilterUsed(false);
                if(fileChooser.showOpenDialog(frame) != JFileChooser.APPROVE_OPTION)
                {
                    return;
                }
                File in = fileChooser.getSelectedFile();
                chooserIn = in.getParentFile();
                config.put("chooserIn", chooserIn.getPath());
                try
                {
                    config.sync();
                }
                catch(BackingStoreException ex)
                {
                    ex.printStackTrace();
                }
                fileChooser = new JFileChooser();
                if(chooserOut != null && chooserOut.exists())
                {
                    fileChooser.setCurrentDirectory(chooserOut);
                }
                fileChooser.setDialogTitle(LANG[lang][7]);
                fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
                fileChooser.setDragEnabled(true);
                String tmp = in.getName();
                final String suggestedName = tmp.substring(0, tmp.length() - 4);
                fileChooser.addPropertyChangeListener(new PropertyChangeListener()
                {
                    public void propertyChange(PropertyChangeEvent ev)
                    {
                        if(JFileChooser.DIRECTORY_CHANGED_PROPERTY.equals(ev.getPropertyName()))
                        {
                            JFileChooser chooser = (JFileChooser)ev.getSource();
                            chooser.setSelectedFile(new File(chooser.getCurrentDirectory(), suggestedName));
                        }
                    }
                });
                fileChooser.setSelectedFile(new File(fileChooser.getCurrentDirectory(), suggestedName));
                if(fileChooser.showSaveDialog(frame) != JFileChooser.APPROVE_OPTION)
                {
                    return;
                }
                chooserOut = fileChooser.getSelectedFile();
                config.put("chooserOut", chooserOut.getPath());
                try
                {
                    config.sync();
                }
                catch(BackingStoreException ex)
                {
                    ex.printStackTrace();
                }
                label.setText(LANG[lang][8]);
                convertMap(in, chooserOut.getPath(), checkbox.isSelected());
                label.setText(LANG[lang][9]);
            }
        });
        final JToggleButton switcher = new JToggleButton("", lang == 1);
        switcher.setSize(16, 12);
        switcher.setIcon(new ImageIcon(FLAGS[0]));
        switcher.setSelectedIcon(new ImageIcon(FLAGS[1]));
        switcher.setToolTipText(LANG[lang][0]);
        switcher.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                config.put("lang", switcher.isSelected() ? "de" : "en");
                try
                {
                    config.sync();
                }
                catch(BackingStoreException ex)
                {
                    ex.printStackTrace();
                }
                lang = switcher.isSelected() ? 1 : 0;
                frame.setTitle(LANG[lang][1].replace("{}", VERSION));
                label.setText(LANG[lang][2].replace("{}", VERSION));
                checkbox.setText(LANG[lang][4]);
                checkbox.setToolTipText(LANG[lang][5]);
                button.setLabel(LANG[lang][3]);
                switcher.setToolTipText(LANG[lang][0]);
            }
        });
        frame.addComponentListener(new ComponentAdapter()
        {
            public void componentResized(ComponentEvent e)
            {
                int height = content.getHeight();
                int x = (content.getWidth() - 300) / 2;
                int y = (height - 150) / 2;
                label.setLocation(x, y + 120);
                checkbox.setLocation(x, y + 80);
                button.setLocation(x, y);
                switcher.setLocation(0, height - 12);
                checkbox.updateUI();
                switcher.updateUI();
            }
        });
        content.add(switcher);
        content.add(button);
        content.add(label);
        content.add(checkbox);
        content.add(new Canvas());
        frame.setVisible(true);
        checkbox.updateUI();
        switcher.updateUI();
    }

    private static void convertMap(File in, String out, boolean newGUID)
    {
        byte[] b = new byte[(int)in.length()];
        try
        {
            FileInputStream istream = new FileInputStream(in);
            istream.read(b);
            istream.close();
            if(readInt(b, 0, 4) != 1)
            {
                throw new MyException(LANG[lang][10]);
            }
            ArrayList<String> dirList = new ArrayList<String>();
            HashMap<String, int[]> fileMap = new HashMap<String, int[]>();
            int pos = 21;
            for(int num = readInt(b, 4, 4) - 1; num > 0; num--)
            {
                int length = readInt(b, pos, 4);
                String name = new String(b, pos + 4, length).replace('\\', File.separatorChar);
                if(name.toLowerCase().startsWith("currentusermap"))
                {
                    dirList.add(name.substring(14));
                }
                else
                {
                    throw new MyException(name.toLowerCase().startsWith("data") ? LANG[lang][12] : LANG[lang][11]);
                }
                pos += length + 8;
            }
            for(int numFiles = readInt(b, 8, 4); numFiles > 0; numFiles--)
            {
                int length = readInt(b, pos, 4);
                String name = new String(b, pos + 4, length).replace('\\', File.separatorChar);
                pos += length + 4;
                if(name.toLowerCase().startsWith("currentusermap"))
                {
                    fileMap.put(name.substring(14), new int[]{readInt(b, pos, 4), readInt(b, pos + 4, 4)});
                }
                else
                {
                    throw new MyException(name.toLowerCase().startsWith("data") ? LANG[lang][12] : LANG[lang][11]);
                }
                pos += 8;
            }
            for(String name : dirList)
            {
                new File(out + name).mkdirs();
            }
            for(Map.Entry<String, int[]> entry : fileMap.entrySet())
            {
                String name = entry.getKey();
                int[] poses = entry.getValue();
                if(name.toLowerCase().endsWith(".cif"))
                {
                    ArrayList<NamedList<String>> ini = new ArrayList<NamedList<String>>();
                    NamedList<String> current = null;
                    int headLen = readInt(b, poses[0] + 36, 4);
                    int bodyLen = readInt(b, poses[0] + 24, 4);
                    byte[] head = decodeCif(b, poses[0] + 40, headLen);
                    byte[] body = decodeCif(b, poses[0] + headLen + 53, bodyLen);
                    int[] cposes = new int[headLen / 4];
                    for(int i = 0; i < cposes.length; i++)
                    {
                        cposes[i] = readInt(head, i * 4, 4);
                    }
                    for(int i = 0; i < cposes.length; i++)
                    {
                        String line = new String(body, cposes[i] + 1, ((i + 1 == cposes.length) ? bodyLen : cposes[i + 1]) - cposes[i] - 2);
                        switch(body[cposes[i]])
                        {
                            case 1:
                                if(line.toLowerCase().equals("logiccontrolend"))
                                {
                                    break;
                                }
                                current = new NamedList<String>(line);
                                ini.add(current);
                                break;
                            case 2:
                                if(newGUID && line.toLowerCase().startsWith("mapguid "))
                                {
                                    line = "mapguid";
                                    Random rand = new Random();
                                    for(int r = 0; r < 16; r++)
                                    {
                                        line += " " + rand.nextInt(256);
                                    }
                                }
                                current.add(line);
                                break;
                            default:
                                throw new MyException(LANG[lang][13].replace("{}", "" + body[cposes[i]]));
                        }
                    }
                    if(name.toLowerCase().equals(File.separator + "map.cif"))
                    {
                        ArrayList<NamedList<String>> map = new ArrayList<NamedList<String>>();
                        ArrayList<NamedList<String>> ai = new ArrayList<NamedList<String>>();
                        ArrayList<NamedList<String>> misc = new ArrayList<NamedList<String>>();
                        ArrayList<NamedList<String>> mission = new ArrayList<NamedList<String>>();
                        ArrayList<NamedList<String>> player = new ArrayList<NamedList<String>>();
                        ArrayList<NamedList<String>> staticobjects = new ArrayList<NamedList<String>>();
                        for(NamedList<String> list : ini)
                        {
                            String lname = list.getName().toLowerCase();
                            NamedList<String> nlist;
                            if(lname.startsWith("misc") || lname.startsWith("player"))
                            {
                                nlist = new NamedList<String>(list.getName());
                                for(String line : list)
                                {
                                    String[] parts = line.split(" ");
                                    String cmd = parts[0].toLowerCase();
                                    if(lname.startsWith("misc_maptype") && cmd.equals("maptype"))
                                    {
                                        parts[1] = MAPTYPE[Integer.parseInt(parts[1])];
                                    }
                                    else if(lname.startsWith("misc_music") && cmd.equals("musictype"))
                                    {
                                        parts[1] = MUSICTYPE[Integer.parseInt(parts[1])];
                                    }
                                    else if(lname.startsWith("misc_tradeagreement") && cmd.equals("tradeagreement"))
                                    {
                                        parts[2] = GOODTYPE[Integer.parseInt(parts[2])];
                                        parts[4] = GOODTYPE[Integer.parseInt(parts[4])];
                                    }
                                    else if(lname.startsWith("misc_multiplayer_goals") && cmd.equals("goalwonwhengoods"))
                                    {
                                        parts[1] = GOODTYPE[Integer.parseInt(parts[1])];
                                    }
                                    else if(lname.startsWith("playerdata") && cmd.equals("player"))
                                    {
                                        parts[2] = PLAYERTYPE[Integer.parseInt(parts[2])];
                                        parts[3] = TRIBETYPE[Integer.parseInt(parts[3])];
                                        parts[4] = COLOR[Integer.parseInt(parts[4])];
                                    }
                                    else if(lname.startsWith("playerdata") && cmd.equals("diplomacy"))
                                    {
                                        parts[3] = DIPLOMACY[Integer.parseInt(parts[3])];
                                    }
                                    else if(lname.startsWith("specialItems") && cmd.equals("add"))
                                    {
                                        int id = Integer.parseInt(parts[2]);
                                        parts[2] = SPECIALITEMTYPE[id];
                                        switch(id)
                                        {
                                            case 2:
                                            case 3:
                                            case 4:
                                                parts[3] = HOUSETYPE[Integer.parseInt(parts[3])];
                                                break;
                                            case 5:
                                                parts[3] = JOBTYPE[Integer.parseInt(parts[3])];
                                                break;
                                            case 6:
                                                parts[3] = GOODTYPE[Integer.parseInt(parts[3])];
                                                break;
                                        }
                                    }
                                    else if(lname.startsWith("allowedthings") && cmd.equals("forbidhouse"))
                                    {
                                        parts[2] = TRIBETYPE[Integer.parseInt(parts[2])];
                                        parts[3] = HOUSETYPE[Integer.parseInt(parts[3])];
                                    }
                                    else if(lname.startsWith("allowedthings") && cmd.equals("forbidjob"))
                                    {
                                        parts[2] = TRIBETYPE[Integer.parseInt(parts[2])];
                                        parts[3] = JOBTYPE[Integer.parseInt(parts[3])];
                                    }
                                    else if(lname.startsWith("allowedthings") && cmd.equals("forbidgood"))
                                    {
                                        parts[2] = TRIBETYPE[Integer.parseInt(parts[2])];
                                        parts[3] = GOODTYPE[Integer.parseInt(parts[3])];
                                    }
                                    else if(lname.startsWith("multiplayer") && cmd.equals("playeroption"))
                                    {
                                        for(int i = 2; i < parts.length; i++)
                                        {
                                            parts[i] = PLAYERTYPE[Integer.parseInt(parts[i])];
                                        }
                                    }
                                    line = parts[0];
                                    for(int i = 1; i < parts.length; i++)
                                    {
                                        line += " " + parts[i];
                                    }
                                    nlist.add(line);
                                }
                            }
                            else
                            {
                                nlist = list;
                            }
                            if(lname.startsWith("logiccontrol"))
                            {
                                map.add(nlist);
                            }
                            else if(lname.startsWith("ai"))
                            {
                                ai.add(nlist);
                            }
                            else if(lname.startsWith("mission"))
                            {
                                mission.add(nlist);
                            }
                            else if(lname.startsWith("player"))
                            {
                                player.add(nlist);
                            }
                            else if(lname.startsWith("staticobjects"))
                            {
                                staticobjects.add(nlist);
                            }
                            else
                            {
                                misc.add(nlist);
                            }
                        }
                        FileOutputStream ostream = new FileOutputStream(out + File.separator + "map.ini");
                        ostream.write(("#include \"$gameroot$\\data\\gamesourceincludes\\logicdefines.inc\"" + NL + NL).getBytes());
                        ostream.write(createIni(map));
                        ostream.write((NL + "#include \"$maproot$\\mission.inc\"" + NL + "#include \"$maproot$\\staticobjects.inc\"" + NL + "#include \"$maproot$\\ai.inc\"" + NL + "#include \"$maproot$\\player.inc\"" + NL + "#include \"$maproot$\\misc.inc\"" + NL).getBytes());
                        ostream.close();
                        ostream = new FileOutputStream(out + File.separator + "ai.inc");
                        ostream.write(createIni(ai));
                        ostream.close();
                        ostream = new FileOutputStream(out + File.separator + "misc.inc");
                        ostream.write(createIni(misc));
                        ostream.close();
                        ostream = new FileOutputStream(out + File.separator + "mission.inc");
                        ostream.write(createIni(mission));
                        ostream.close();
                        ostream = new FileOutputStream(out + File.separator + "player.inc");
                        ostream.write(createIni(player));
                        ostream.close();
                        ostream = new FileOutputStream(out + File.separator + "staticobjects.inc");
                        ostream.write(createIni(staticobjects));
                        ostream.close();
                    }
                    else
                    {
                        FileOutputStream ostream = new FileOutputStream(out + name.substring(0, name.length() - 4) + ".ini");
                        ostream.write(createIni(ini));
                        ostream.close();
                    }
                }
                else
                {
                    FileOutputStream ostream = new FileOutputStream(out + name);
                    ostream.write(b, poses[0], poses[1]);
                    ostream.close();
                }
            }
        }
        catch(MyException e)
        {
            e.printStackTrace();
            JOptionPane.showMessageDialog(frame, e.getMessage());
        }
        catch(Exception e)
        {
            e.printStackTrace();
            JOptionPane.showMessageDialog(frame, e.getClass().getName() + ": " + e.getMessage());
        }
    }

    private static int readInt(byte[] b, int off, int len)
    {
        int v = 0;
        for(int i = 0; i < len; i++)
        {
            v += (b[off + i] & 0xFF) << (i * 8);
        }
        return v;
    }

    private static byte[] decodeCif(byte[] data, int off, int len)
    {
        byte[] back = new byte[len];
        int c = 71;
        int d = 126;
        for(int i = 0; i < len; i++)
        {
            back[i] = (byte)(((data[off + i] & 0xFF) - 1) ^ c);
            c += d;
            d += 33;
        }
        return back;
    }

    private static byte[] createIni(ArrayList<NamedList<String>> ini) throws IOException
    {
        int count = 0;
        boolean first = true;
        ByteArrayOutputStream stream = new ByteArrayOutputStream();
        for(NamedList<String> list : ini)
        {
            if(!first)
            {
                stream.write(newLine);
            }
            else
            {
                first = false;
            }
            String secName = list.getName();
            if(secName.toLowerCase().equals("missiondata"))
            {
                stream.write(("// MissionId_" + count).getBytes());
                stream.write(newLine);
                count++;
            }
            stream.write(("[" + secName + "]").getBytes());
            stream.write(newLine);
            for(String line : list)
            {
                stream.write(line.getBytes());
                stream.write(newLine);
            }
            if(secName.toLowerCase().equals("logiccontrol"))
            {
                stream.write("[logiccontrolend]".getBytes());
                stream.write(newLine);
            }
        }
        return stream.toByteArray();
    }

    private static class NamedList<T> extends ArrayList<T>
    {
        private final String name;

        public NamedList(String name)
        {
            this.name = name;
        }

        public String getName()
        {
            return this.name;
        }
    }

    private static class MyException extends Exception
    {
        public MyException(String message)
        {
            super(message);
        }
    }
}
